use crate::routes::FormData;

use super::{SubscriberEmail, SubscriberName};

pub struct NewSubscriber {
    pub email: SubscriberEmail,
    pub name: SubscriberName,
}

impl TryFrom<FormData> for NewSubscriber {
    type Error = String;

    fn try_from(form: FormData) -> Result<Self, Self::Error> {
        Ok(NewSubscriber {
            email: match SubscriberEmail::parse(form.email) {
                Ok(value) => value,
                Err(message) => return Err(format!("email field: {}", message)),
            },
            name: match SubscriberName::parse(form.name) {
                Ok(value) => value,
                Err(message) => return Err(format!("name field: {}", message)),
            },
        })
    }
}
